﻿Network activity
================

This section offers a brief overview of all the visible network activity that a DECODE NODE produces when operated.

## Local network

On bootup, DECODE nodes will request DHCP over Ethernet.

In case of lack of DHCP the box will boot after a delay, but will not be online and will not join the DECODE network. The board can eventually be configured by hand by connecting a keyboard and an HDMI monitor.

## Incoming traffic

DECODE nodes do not require any input ports to be open of forwarded, nor any UPNP capability on the LAN gateway. Nodes route all their traffic via the Tor network and offer the possibility to application space utilities to receive any communication via Socks5 protocol router by Tor. This also means that there are no common firewall configurations that can stop the DECODE node from connecting: once it has DHCP and at least web access it will manage to join the Tor network and get in touch with all the DECODE network.

## Outgoing traffic

Once received a local IP via DHCP, DECODE nodes build outgoing connections to:

1. pool.ntp.org (port 123) to get current time
2. dam.decodeproject.eu (port 80) to see if there are available system updates
3. if there are updates, dam.decodeproject.eu:80 is accessed again to download the update

These is the only deterministic traffic produced by a DECODE node upon boot and can be considered a base for fingerprinting nodes running on the local network, recognising them from this initial behavior. All subsequent connections are routed through Tor and therefore opaque even to the local network administrators.

## Continued operation

Once this first configuration phase (initramfs phase) is done, we continue booting into the actual system. The system will again request NTP on outbound port 123 and continue by starting all the remaining services in userspace. All services are tunneled through Tor socks and therefore do not require any inbound or outbound connections outside of Tor.

Tor's network requirements can be found in the Tor Project FAQ, most notably:

- [Tor Outbound Ports documentation](https://www.torproject.org/docs/faq.html.en#OutboundPorts)
- [Tor Firewall Ports documentation](https://www.torproject.org/docs/faq.html.en#FirewallPorts)

DECODE nodes operate only as hidden services inside Tor and connect only to other DECODE nodes: they do not act as entry, relay or exit nodes for the Tor network.
